# Originally generated by rust2rpm 16
%define dracutlibdir %{_prefix}/lib/dracut
%bcond_without check
%global __cargo_skip_build 0
# The library is for internal code reuse and is not a public API
%global __cargo_is_lib 0

%global dracutcommit 38d9f618cd6817ec7c1f1797b273d6f1f46852cb
%global dracutshortcommit %(c=%{dracutcommit}; echo ${c:0:7})

%global crate coreos-installer

Name:           %{crate}
Version:        0.17.0
Release:        1.rhaos4.14%{?dist}
Summary:        Installer for Fedora CoreOS and RHEL CoreOS

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            https://crates.io/crates/coreos-installer
Source0:        https://crates.io/api/v1/crates/%{crate}/%{version}/download#/%{crate}-%{version}.crate
# not used on Fedora
Source1:        https://github.com/coreos/%{crate}/releases/download/v%{version}/%{crate}-%{version}-vendor.tar.gz
Source2:        https://github.com/coreos/coreos-installer-dracut/archive/%{dracutcommit}/coreos-installer-dracut-%{dracutshortcommit}.tar.gz

# The RHEL 8 rust-toolset macros don't let us enable features from the
# %%cargo_* macros.  Enable rdcore directly in Cargo.toml.
Patch0:         enable-rdcore.patch

ExclusiveArch:  %{rust_arches}
%if 0%{?rhel} && !0%{?eln}
BuildRequires:  rust-toolset
BuildRequires:  openssl-devel
# To ensure we're not bundling system libraries
BuildRequires:  xz-devel
%else
BuildRequires:  rust-packaging
%endif
BuildRequires:  systemd-rpm-macros
BuildRequires:  libzstd-devel
# For tests
BuildRequires:  gnupg2

%global _description %{expand:
coreos-installer installs Fedora CoreOS or RHEL CoreOS to bare-metal
machines (or, occasionally, to virtual machines).
}

%description %{_description}

Summary:        %{summary}
# ASL 2.0
# ASL 2.0 or Boost
# MIT
# MIT or ASL 2.0
# Unlicense or MIT
# zlib
License:        ASL 2.0 and MIT and zlib

Requires:       gnupg
Requires:       kpartx
Requires:       systemd-udev
Requires:       util-linux
%ifarch s390x
# This should be spelled "s390utils-core" but some of the binaries are
# still moving over from s390utils-base
Requires:       /usr/sbin/chreipl
Requires:       /usr/sbin/dasdfmt
Requires:       /usr/sbin/fdasd
Requires:       /usr/sbin/lszdev
Requires:       /usr/sbin/zipl
%endif

# Since `rust-coreos-installer` creates a `coreos-installer`
# subpackage with a newer version number, which supersedes the
# deprecated `coreos-installer` package (https://src.fedoraproject.org/rpms/coreos-installer),
# an explicit `Obsoletes:` for `coreos-installer` is not necessary.

# Obsolete dracut modules as they are not provided in this package.
Obsoletes:      coreos-installer-dracut < 0.0.1

%description -n %{crate} %{_description}

%prep
%autosetup -n %{crate}-%{version} -p1 -a 2
%if 0%{?rhel} && !0%{?eln}
tar xvf %{SOURCE1}
mkdir -p .cargo
cat >.cargo/config << EOF
[source.crates-io]
replace-with = "vendored-sources"

[source.vendored-sources]
directory = "vendor"
EOF
%else
%cargo_prep
%endif
# Fix SIGSEGV in tests on s390x
# https://bugzilla.redhat.com/show_bug.cgi?id=1883457
sed -i 's/"-Ccodegen-units=1",//' .cargo/config

%if !0%{?rhel} || 0%{?eln}
%generate_buildrequires
%cargo_generate_buildrequires -f rdcore
%endif

%build
%if 0%{?rhel} && !0%{?eln}
%cargo_build
%else
%cargo_build -f rdcore
%endif

%install
%if 0%{?rhel} && !0%{?eln}
%make_install RELEASE=1
# 51coreos-installer for coreos-installer-dracut
%make_install -C coreos-installer-dracut-%{dracutcommit}
%else
%cargo_install -f rdcore
# Install binaries, dracut modules, units, targets, generators for running via systemd
install -D -m 0755 -t %{buildroot}%{dracutlibdir}/modules.d/50rdcore dracut/50rdcore/module-setup.sh
make install-scripts DESTDIR=%{buildroot}
make install-systemd DESTDIR=%{buildroot}
make install-man DESTDIR=%{buildroot}
make install-data DESTDIR=%{buildroot}
mv %{buildroot}%{_bindir}/rdcore %{buildroot}%{dracutlibdir}/modules.d/50rdcore/
%endif

%package     -n %{crate}-bootinfra
Summary:     %{crate} boot-time infrastructure for use on Fedora/RHEL CoreOS
Requires:    %{crate}%{?_isa} = %{?epoch:%{epoch}:}%{version}-%{release}
# ASL 2.0
# ASL 2.0 or Boost
# MIT
# MIT or ASL 2.0
# Unlicense or MIT
# zlib
License:     ASL 2.0 and MIT and zlib

# Package was renamed from coreos-installer-systemd when rdcore was added
Provides:    %{crate}-systemd = %{version}-%{release}
Obsoletes:   %{crate}-systemd <= 0.3.0-3

%description -n %{crate}-bootinfra
This subpackage contains boot-time infrastructure for Fedora CoreOS and
RHEL CoreOS.  It is not needed on other platforms.

%files       -n %{crate}-bootinfra
%{dracutlibdir}/modules.d/50rdcore
%{_libexecdir}/*
%{_unitdir}/*
%{_systemdgeneratordir}/*

%if 0%{?rhel} && !0%{?eln}
%package     -n %{crate}-dracut
Summary:     Dracut module for running coreos-installer in the initrd
Requires:    %{crate} = %{version}-%{release}

%description -n %{crate}-dracut
This subpackage contains files and configuration to run coreos-installer
from the initramfs.

%files       -n %{crate}-dracut
%{dracutlibdir}/modules.d/51coreos-installer
%endif

%files       -n %{crate}
%license LICENSE
%doc README.md
%{_bindir}/coreos-installer
%{_mandir}/man8/*
%dir %{_datadir}/coreos-installer
%{_datadir}/coreos-installer/example-config.yaml

%if %{with check}
%check
%if 0%{?rhel} && !0%{?eln}
%cargo_test
%else
%cargo_test -f rdcore
%endif
%endif

%changelog
* Fri Mar 10 2023 Benjamin Gilbert <bgilbert@redhat.com> - 0.17.0-1
- New release

* Mon Sep 19 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.16.1-1
- New release
- Sync coreos-installer-dracut with CentOS Stream 9

* Fri Sep 16 2022 Steven Presti <spresti@redhat.com> - 0.16.0-1
- New release
- Add libzstd dependency

* Sun Jul 10 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.15.0-2
- Sync coreos-installer-dracut with CentOS Stream 9

* Wed Jun 22 2022 Michael Armijo <marmijo@redhat.com> - 0.15.0-1
- New release

* Wed Apr 27 2022 Jonathan Lebon <jlebon@redhat.com> - 0.14.0-1
- New release

* Mon Feb 14 2022 Jonathan Lebon <jlebon@redhat.com> - 0.13.1-1
- New release

* Fri Dec 17 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.12.0-1
- New release

* Wed Dec 08 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.11.0-2
- Fix inadvertent inclusion of coreos-installer-dracut in -bootinfra
- Have -dracut own 51coreos-installer directory

* Wed Dec 08 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.11.0-1
- New release

* Tue Dec 07 2021 Sohan Kunkerkar <skunkerk@redhat.com> - 0.10.1-3
- Remove conditional around sourcing the vendor tarball

* Mon Nov 08 2021 Sohan Kunkerkar <skunkerk@redhat.com> - 0.10.1-2
- Vendor rust dependencies on RHEL only
- add coreos-installer-dracut subpackage on RHEL only

* Tue Oct 12 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.10.1-1
- New release

* Thu Sep 23 2021 Jan Schintag <jschinta@redhat.com> - 0.10.0-2
- Add zipl helper script to initramfs to support device mapper

* Tue Aug 31 2021 Jan Schintag <jschinta@redhat.com> - 0.10.0-1
- Bump version to 0.10.0

* Mon Jun 21 2021 Jonathan Lebon <jlebon@redhat.com> - 0.9.1-4
- Add xz-devel BR to ensure we're not bundling
  Related: https://bugzilla.redhat.com/show_bug.cgi?id=1974453

* Thu Jun 10 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.9.1-3
- Support s390x DASDs in VMs via virtio

* Tue Jun 08 2021 Dusty Mabe <dustymabe@redhat.com> - 0.9.1-2
- Add coreos.force_persist_ip karg forwarding

* Wed Apr 21 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.9.0-3
- Improve error message for busy disk referenced via symlink
- Fix failure on corrupt GPT

* Fri Apr 9 2021 Sohan Kunkerkar <skunkerk@redhat.com> - 0.9.0-2
- Use macro for dracut library path

* Thu Apr 8 2021 Sohan Kunkerkar <skunkerk@redhat.com> - 0.9.0-1
- New release

* Fri Jan 15 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.8.0-3
- Fix rdcore rootmap on RAID devices

* Tue Jan 12 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.8.0-2
- Disable LTO again to avoid crashes on s390x

* Tue Jan 12 2021 Sohan Kunkerkar <skunkerk@redhat.com> - 0.8.0-1
- New release

* Mon Jan 04 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.7.2-2
- Add Requires for programs invoked by coreos-installer
- Require Rust >= 1.45, re-enable LTO

* Thu Oct 22 2020 Sohan Kunkerkar <skunkerk@redhat.com> - 0.7.2-1
- New release

* Mon Sep 21 2020 Benjamin Gilbert <bgilbert@redhat.com> - 0.6.0-3
- Fix MBR handling when partition saving is enabled
- Fix base package Obsoletes being interpreted as part of package description

* Wed Sep 02 2020 Benjamin Gilbert <bgilbert@redhat.com> - 0.6.0-2
- Disable LTO on s390x to avoid runtime crashes
- Drop legacy installer

* Tue Aug 25 2020 Benjamin Gilbert <bgilbert@redhat.com> - 0.6.0-1
- New release

* Fri Jul 31 2020 Benjamin Gilbert <bgilbert@redhat.com> - 0.5.0-1
- New release

* Sat Jul 25 2020 Benjamin Gilbert <bgilbert@redhat.com> - 0.4.0-1
- New release
- Rename -systemd subpackage to -bootinfra
- Add rdcore Dracut module to -bootinfra

* Wed Jul 22 2020 Benjamin Gilbert <bgilbert@redhat.com> - 0.3.0-1
- New release
- Make coreos-installer-{service,generator} world-readable

* Wed Jun 17 2020 Dusty Mabe <dusty@dustymabe.com> - 0.2.0-4.rhaos4.6
- Include rhaos4.6 in the rpm release field

* Thu May 28 2020 Colin Walters <walters@verbum.org> - 0.2.0-3
- Backport osmet RHCOS+LUKS patches

* Thu May 07 2020 Dusty Mabe <dusty@dustymabe.com> - 0.2.0-2
- Fix bug in dracut hook in legacy installer; see
  https://github.com/coreos/coreos-installer/pull/234

* Mon Apr 27 2020 Colin Walters <walters@verbum.org> - 0.1.3-4
- Merge in legacy installer; see
  https://github.com/coreos/coreos-installer/pull/220

* Mon Mar 23 2020 Colin Walters <walters@verbum.org> - 0.1.3-2
- https://github.com/coreos/coreos-installer/releases/tag/v0.1.3

* Wed Mar 04 2020 Colin Walters <walters@verbum.org> - 0.1.2-11
- Backport no-signatures-available patch

* Wed Feb 26 2020 Colin Walters <walters@verbum.org> - 0.1.2-10
- Forked from Fedora
- I forgot about the weird `rust-` package name prefixing when
  asking RCM to make the dist-git repo, and rather than redo
  that I decided to just go with it.
- Stop depending on systemd-rpm-macros since it's not in RHEL8 apparently
- Drop other things only applicable to Fedora Rust packaging like
  dynamic buildrequires
